    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.security.Identity

    java.lang.Object
       |
       +----java.security.Identity

public abstract class Identity
extends Object
implements Principal, Serializable

This class represents identities: real-world objects such as people, companies or organizations whose identities can be authenticated using their public keys. Identities may also be more abstract (or concrete) constructs, such as daemon threads or smart cards.

All Identity objects have a name and a public key. Names are immutable. Identities may also be scoped. That is, if an Identity is specified to have a particular scope, then the name and public key of the Identity are unique within that scope.

An Identity also has a set of certificates (all certifying its own public key). The Principal names specified in these certificates need not be the same, only the key.

An Identity can be subclassed, to include postal and email addresses, telephone numbers, images of faces and logos, and so on.

See Also:
  IdentityScope, Signer, Principal

##

Identity()
  Constructor for serialization only.
Identity(String)
  Constructs an identity with the specified name and no scope.
Identity(String, IdentityScope)
  Constructs an identity with the specified name and scope.

##

addCertificate(Certificate)
  Adds a certificate for this identity.
certificates()
  Returns a copy of all the certificates for this identity.
equals(Object)
  Tests for equality between the specified object and this identity.
getInfo()
  Returns general information previously specified for this identity.
getName()
  Returns this identity's name.
getPublicKey()
  Returns this identity's public key.
getScope()
  Returns this identity's scope.
hashCode()
  Returns a hashcode for this identity.
identityEquals(Identity)
  Tests for equality between the specified identity and this identity.
removeCertificate(Certificate)
  Removes a certificate from this identity.
setInfo(String)
  Specifies a general information string for this identity.
setPublicKey(PublicKey)
  Sets this identity's public key.
toString()
  Returns a short string describing this identity, telling its name and its scope (if any).
toString(boolean)
  Returns a string representation of this identity, with optionally more details than that provided by the `toString` method without any arguments.

##

Identity

     protected Identity()

  Constructor for serialization only.

Identity

     public Identity(String name,
                     IdentityScope scope) throws KeyManagementException

  Constructs an identity with the specified name and scope.

  Parameters:
    name - the identity name.
    scope - the scope of the identity.
  Throws: KeyManagementException
    if there is already an identity with the same name in the scope.

Identity

     public Identity(String name)

  Constructs an identity with the specified name and no scope.

  Parameters:
    name - the identity name.

##

getName

     public final String getName()

  Returns this identity's name.

  Returns:
    the name of this identity.

getScope

     public final IdentityScope getScope()

  Returns this identity's scope.

  Returns:
    the scope of this identity.

getPublicKey

     public PublicKey getPublicKey()

  Returns this identity's public key.

  Returns:
    the public key for this identity.

setPublicKey

     public void setPublicKey(PublicKey key) throws KeyManagementException

  Sets this identity's public key. The old key and all of this identity's certificates are removed by this operation.

  Parameters:
    key - the public key for this identity.
  Throws: KeyManagementException
    if another identity in the identity's scope has the same public key, or if another exception occurs.

setInfo

     public void setInfo(String info)

  Specifies a general information string for this identity.

  Parameters:
    info - the information string.
  See Also:
    getInfo

getInfo

     public String getInfo()

  Returns general information previously specified for this identity.

  Returns:
    general information about this identity.
  See Also:
    setInfo

addCertificate

     public void addCertificate(Certificate certificate) throws KeyManagementException

  Adds a certificate for this identity. If the identity has a public key, the public key in the certificate must be the same, and if the identity does not have a public key, the identity's public key is set to be that specified in the certificate.

  Parameters:
    certificate - the certificate to be added.
  Throws: KeyManagementException
    if the certificate is not valid, if the public key in the certificate being added conflicts with this identity's public key, or if another exception occurs.

removeCertificate

     public void removeCertificate(Certificate certificate) throws KeyManagementException

  Removes a certificate from this identity.

  Parameters:
    certificate - the certificate to be removed.
  Throws: KeyManagementException
    if the certificate is missing, or if another exception occurs.

certificates

     public Certificate[] certificates()

  Returns a copy of all the certificates for this identity.

  Returns:
    a copy of all the certificates for this identity.

equals

     public final boolean equals(Object identity)

  Tests for equality between the specified object and this identity. This first tests to see if the entities actually refer to the same object, in which case it returns true. Next, it checks to see if the entities have the same name and the same scope. If they do, the method returns true. Otherwise, it calls identityEquals, which subclasses should override.

  Parameters:
    identity - the object to test for equality with this identity.
  Returns:
    true if the objects are considered equal, false otherwise.
  Overrides:
    equals in class Object
  See Also:
    identityEquals

identityEquals

     protected boolean identityEquals(Identity identity)

  Tests for equality between the specified identity and this identity. This method should be overriden by subclasses to test for equality. The default behavior is to return true if the names and public keys are equal.

  Parameters:
    identity - the identity to test for equality with this identity.
  Returns:
    true if the identities are considered equal, false otherwise.
  See Also:
    equals

toString

     public String toString()

  Returns a short string describing this identity, telling its name and its scope (if any).

  Returns:
    information about this identity, such as its name and the name of its scope (if any).
  Overrides:
    toString in class Object

toString

     public String toString(boolean detailed)

  Returns a string representation of this identity, with optionally more details than that provided by the `toString` method without any arguments.

  Parameters:
    detailed - whether or not to provide detailed information.
  Returns:
    information about this identity. If `detailed` is true, then this method returns more information than that provided by the `toString` method without any arguments.
  See Also:
    toString

hashCode

     public int hashCode()

  Returns a hashcode for this identity.

  Returns:
    a hashcode for this identity.
  Overrides:
    hashCode in class Object

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.